﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace HitAndBlow
{
    public partial class Form1 : Form
    {
        int movement = 0;
        int[] answer = new int[4];
        int turn = 1;
        Color[] colors = { Color.Black, Color.Blue , Color.Red, Color.Green, Color.Yellow, Color.Cyan};
        Point[] PcePos = new Point[5];

        public Form1()
        {
            InitializeComponent();
        }

        private void 終了XToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Dispose();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            for (int i = 1; i <= 25; i++)
            {
                dataGridView1.Columns.Add("Answer" + i.ToString(), i.ToString());
            }
            
            dataGridView1.Rows.Add(6);
            dataGridView1.RowTemplate.Height = 2;
            for (int i = 0; i < 6; i++)
            {
                dataGridView1.Rows[i].Height = 11;
            }

            PcePos[0] = Pic_Piece1.Location;
            PcePos[1] = Pic_Piece2.Location;
            PcePos[2] = Pic_Piece3.Location;
            PcePos[3] = Pic_Piece4.Location;
            PcePos[4] = Pic_Piece5.Location;
        }

        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {
            switch (movement)
            {
                case 1:
                    Pic_Piece1.SetBounds(e.X - 32, e.Y - 32, 0, 0, BoundsSpecified.Location);
                    break;
                case 2:
                    Pic_Piece2.SetBounds(e.X - 32, e.Y - 32, 0, 0, BoundsSpecified.Location);
                    break;
                case 3:
                    Pic_Piece3.SetBounds(e.X - 32, e.Y - 32, 0, 0, BoundsSpecified.Location);
                    break;
                case 4:
                    Pic_Piece4.SetBounds(e.X - 32, e.Y - 32, 0, 0, BoundsSpecified.Location);
                    break;
                case 5:
                    Pic_Piece5.SetBounds(e.X - 32, e.Y - 32, 0, 0, BoundsSpecified.Location);
                    break;
                default:
                    break;
            }
        }

        private void Form1_MouseClick(object sender, MouseEventArgs e)
        {
            if (MouseButtons.Right.Equals(e.Button))
            {
                movement = 0;
            }
        }

        private void Pic_Piece1_MouseClick(object sender, MouseEventArgs e)
        {
            PieceClickProcess(1,e.Button);
        }

        private void PieceClickProcess(int pMovement, MouseButtons bt)
        {
            switch (bt)
            {
                case MouseButtons.Left:
                    if (movement == 0)
                    {
                        movement = pMovement;
                    }
                    else
                    {
                        movement = 0;
                    }
                    break;
                case MouseButtons.Right:
                    movement = 0;
                    break;
                default:
                    break;
            }
        }

        private void Pic_Piece2_MouseClick(object sender, MouseEventArgs e)
        {
            PieceClickProcess(2, e.Button);
        }

        private void Pic_Piece3_MouseClick(object sender, MouseEventArgs e)
        {
            PieceClickProcess(3, e.Button);
        }

        private void Pic_Piece4_MouseClick(object sender, MouseEventArgs e)
        {
            PieceClickProcess(4, e.Button);
        }

        private void Pic_Piece5_MouseClick(object sender, MouseEventArgs e)
        {
            PieceClickProcess(5, e.Button);
        }

        private void Pic_Piece1_MouseMove(object sender, MouseEventArgs e)
        {
            e=new MouseEventArgs(MouseButtons.Left, 0, MousePosition.X-this.Location.X, MousePosition.Y-this.Location.Y, 0);
            Form1_MouseMove(this, e);
        }

        private void Pic_Piece2_MouseMove(object sender, MouseEventArgs e)
        {
            e = new MouseEventArgs(MouseButtons.Left, 0, MousePosition.X - this.Location.X, MousePosition.Y - this.Location.Y, 0);
            Form1_MouseMove(this, e);
        }

        private void Pic_Piece3_MouseMove(object sender, MouseEventArgs e)
        {
            e = new MouseEventArgs(MouseButtons.Left, 0, MousePosition.X - this.Location.X, MousePosition.Y - this.Location.Y, 0);
            Form1_MouseMove(this, e);
        }

        private void Pic_Piece4_MouseMove(object sender, MouseEventArgs e)
        {
            e = new MouseEventArgs(MouseButtons.Left, 0, MousePosition.X - this.Location.X, MousePosition.Y - this.Location.Y, 0);
            Form1_MouseMove(this, e);
        }

        private void Pic_Piece5_MouseMove(object sender, MouseEventArgs e)
        {
            e = new MouseEventArgs(MouseButtons.Left, 0, MousePosition.X - this.Location.X, MousePosition.Y - this.Location.Y, 0);
            Form1_MouseMove(this, e);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Judge();
            turn++;
        }

        private bool Judge()
        {
            bool result = false;
            int[] userAnswer = new int[4];

            userAnswer[0] = PieceCheck(Pic_Place1);
            userAnswer[1] = PieceCheck(Pic_Place2);
            userAnswer[2] = PieceCheck(Pic_Place3);
            userAnswer[3] = PieceCheck(Pic_Place4);

            int hit = 0;
            int blow = 0;

            for (int i = 0; i < 4; i++)
            {
                //Console.WriteLine("userAnswer[{0}]={1}", i, userAnswer[i]);
                if (answer[i] == userAnswer[i])
                {
                    hit++;
                }
                else
                {
                    for (int j = 0; j < 4; j++)
                    {
                        if (answer[j] == userAnswer[i])
                        {
                            blow++;
                        }
                    }
                }
            }

            Lbl_HitNum.Text = hit.ToString();
            Lbl_BlowNum.Text = blow.ToString();

            if (turn >= dataGridView1.Columns.Count)
            {
                dataGridView1.Columns.Add("Answer" + (turn+1).ToString(), (turn+1).ToString());
            }

            for (int i = 0; i < 4; i++)
            {
                dataGridView1.Rows[i].Cells[turn-1].Style.BackColor = colors[userAnswer[i]];
            }
            dataGridView1.Rows[4].Cells[turn-1].Value = hit.ToString();
            dataGridView1.Rows[5].Cells[turn-1].Value = blow.ToString();

            if (hit == 4)
            {
                Pic_Answer1.BackColor = colors[answer[0]];
                Pic_Answer2.BackColor = colors[answer[1]];
                Pic_Answer3.BackColor = colors[answer[2]];
                Pic_Answer4.BackColor = colors[answer[3]];

                MessageBox.Show("Congraturations!!");
                Btn_OK.Enabled = false;
            }

            return result;
        }

        private int PieceCheck(PictureBox PicPlace)
        {
            int result = 0;

            if (PieceCheckSub(Pic_Piece1, PicPlace))
            {
                result = 1;
            }
            if (PieceCheckSub(Pic_Piece2, PicPlace))
            {
                result = 2;
            }
            if (PieceCheckSub(Pic_Piece3, PicPlace))
            {
                result = 3;
            }
            if (PieceCheckSub(Pic_Piece4, PicPlace))
            {
                result = 4;
            }
            if (PieceCheckSub(Pic_Piece5, PicPlace))
            {
                result = 5;
            }

            return result;
        }

        private bool PieceCheckSub(PictureBox p1, PictureBox p2)
        {
            bool result = false;
            int R = 1000;
            int x1, y1;

            x1 = p1.Location.X;
            y1 = p1.Location.Y;

            int x2, y2;
            x2 = p2.Location.X;
            y2 = p2.Location.Y;

            int rr = (x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1);
            if (rr < R)
            {
                result = true;
            }

            return result;
        }

        private void dataGridView1_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void 新規ゲームNToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // OKボタンを押下可能にする
            Btn_OK.Enabled = true;

            // 答えの作成
            Random rnd = new Random();
            for (int i = 0; i < 4; i++)
            {
                bool flag = true;
                do
                {
                    // 答えを仮決定
                    answer[i] = rnd.Next(1, 6);
                    
                    // 重複チェック
                    flag = true;
                    for (int j = 0; j < i; j++)
                    {
                        if (answer[j] == answer[i]) { flag = false; }
                    }
                } while (!flag);

                Console.WriteLine("answer[{0}]={1}", i, answer[i]);
            }

            // グリッドのクリア
            for (int i = 0; i < dataGridView1.Columns.Count; i++)
            {
                for (int j = 0; j < 6; j++)
                {
                    dataGridView1.Rows[j].Cells[i].Style.BackColor = Color.White;
                    dataGridView1.Rows[j].Cells[i].Value = "";
                }
            }

            // turnを1に初期化
            turn = 1;

            // 駒を元の場所に戻す
            Pic_Piece1.Location = PcePos[0];
            Pic_Piece2.Location = PcePos[1];
            Pic_Piece3.Location = PcePos[2];
            Pic_Piece4.Location = PcePos[3];
            Pic_Piece5.Location = PcePos[4];

            // 答えの表示を伏せる
            Pic_Answer1.BackColor = colors[0];
            Pic_Answer2.BackColor = colors[0];
            Pic_Answer3.BackColor = colors[0];
            Pic_Answer4.BackColor = colors[0];
        }

    }
}